unit schReferenciaGenericaClient_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID__ExisteFilaReferenciaGenerica = '{D1595576-9979-4EBB-840B-FF8B69E9AF21}';
  RID_InformeRefGenerica = '{C8CFA7EB-16B5-4AB4-A583-3EBD915B44B8}';
  RID_GetProducto = '{5D97B590-D22E-4D97-AFC6-400986B4D9FA}';
  RID_ReferenciaGenerica = '{A40BCD4C-E370-497D-8C28-118CBC1A3664}';

  { Data table names }
  nme__ExisteFilaReferenciaGenerica = '_ExisteFilaReferenciaGenerica';
  nme_InformeRefGenerica = 'InformeRefGenerica';
  nme_GetProducto = 'GetProducto';
  nme_ReferenciaGenerica = 'ReferenciaGenerica';

  { _ExisteFilaReferenciaGenerica fields }
  fld__ExisteFilaReferenciaGenericaNUMINF = 'NUMINF';
  fld__ExisteFilaReferenciaGenericaCLAVE1 = 'CLAVE1';
  fld__ExisteFilaReferenciaGenericaCLAVE2 = 'CLAVE2';
  fld__ExisteFilaReferenciaGenericaCLAVE3 = 'CLAVE3';
  fld__ExisteFilaReferenciaGenericaNUMCON = 'NUMCON';

  { _ExisteFilaReferenciaGenerica field indexes }
  idx__ExisteFilaReferenciaGenericaNUMINF = 0;
  idx__ExisteFilaReferenciaGenericaCLAVE1 = 1;
  idx__ExisteFilaReferenciaGenericaCLAVE2 = 2;
  idx__ExisteFilaReferenciaGenericaCLAVE3 = 3;
  idx__ExisteFilaReferenciaGenericaNUMCON = 4;

  { InformeRefGenerica fields }
  fld_InformeRefGenericaCODCENTRO = 'CODCENTRO';
  fld_InformeRefGenericaCENTRO = 'CENTRO';
  fld_InformeRefGenericaCODVENDEDOR = 'CODVENDEDOR';
  fld_InformeRefGenericaVENDEDOR = 'VENDEDOR';
  fld_InformeRefGenericaFECHA = 'FECHA';
  fld_InformeRefGenericaNUMTALON = 'NUMTALON';
  fld_InformeRefGenericaCANTIDAD = 'CANTIDAD';
  fld_InformeRefGenericaVALTOT = 'VALTOT';

  { InformeRefGenerica field indexes }
  idx_InformeRefGenericaCODCENTRO = 0;
  idx_InformeRefGenericaCENTRO = 1;
  idx_InformeRefGenericaCODVENDEDOR = 2;
  idx_InformeRefGenericaVENDEDOR = 3;
  idx_InformeRefGenericaFECHA = 4;
  idx_InformeRefGenericaNUMTALON = 5;
  idx_InformeRefGenericaCANTIDAD = 6;
  idx_InformeRefGenericaVALTOT = 7;

  { GetProducto fields }
  fld_GetProductoCODIGO_BARRA = 'CODIGO_BARRA';
  fld_GetProductoCOR_PRODUTO = 'COR_PRODUTO';
  fld_GetProductoDESC_PRODUTO = 'DESC_PRODUTO';
  fld_GetProductoPRODUTO = 'PRODUTO';
  fld_GetProductoGRADE = 'GRADE';

  { GetProducto field indexes }
  idx_GetProductoCODIGO_BARRA = 0;
  idx_GetProductoCOR_PRODUTO = 1;
  idx_GetProductoDESC_PRODUTO = 2;
  idx_GetProductoPRODUTO = 3;
  idx_GetProductoGRADE = 4;

  { ReferenciaGenerica fields }
  fld_ReferenciaGenericaNUMINF = 'NUMINF';
  fld_ReferenciaGenericaCLAVE1 = 'CLAVE1';
  fld_ReferenciaGenericaCLAVE2 = 'CLAVE2';
  fld_ReferenciaGenericaCLAVE3 = 'CLAVE3';
  fld_ReferenciaGenericaNUMCON = 'NUMCON';
  fld_ReferenciaGenericaFECHA = 'FECHA';
  fld_ReferenciaGenericaCODCENTRO = 'CODCENTRO';
  fld_ReferenciaGenericaCENTRO = 'CENTRO';
  fld_ReferenciaGenericaCODVENDEDOR = 'CODVENDEDOR';
  fld_ReferenciaGenericaVENDEDOR = 'VENDEDOR';
  fld_ReferenciaGenericaNUMTALON = 'NUMTALON';
  fld_ReferenciaGenericaCODIGO_BARRA = 'CODIGO_BARRA';
  fld_ReferenciaGenericaCODIGO = 'CODIGO';
  fld_ReferenciaGenericaPRODUCTO = 'PRODUCTO';
  fld_ReferenciaGenericaCOLOR = 'COLOR';
  fld_ReferenciaGenericaTALLA = 'TALLA';
  fld_ReferenciaGenericaVTAPROCESO = 'VTAPROCESO';
  fld_ReferenciaGenericaVTAFINAL = 'VTAFINAL';
  fld_ReferenciaGenericaVTATERM = 'VTATERM';
  fld_ReferenciaGenericaVALTOT = 'VALTOT';
  fld_ReferenciaGenericaESTADO = 'ESTADO';
  fld_ReferenciaGenericaFECHACAMBIO = 'FECHACAMBIO';

  { ReferenciaGenerica field indexes }
  idx_ReferenciaGenericaNUMINF = 0;
  idx_ReferenciaGenericaCLAVE1 = 1;
  idx_ReferenciaGenericaCLAVE2 = 2;
  idx_ReferenciaGenericaCLAVE3 = 3;
  idx_ReferenciaGenericaNUMCON = 4;
  idx_ReferenciaGenericaFECHA = 5;
  idx_ReferenciaGenericaCODCENTRO = 6;
  idx_ReferenciaGenericaCENTRO = 7;
  idx_ReferenciaGenericaCODVENDEDOR = 8;
  idx_ReferenciaGenericaVENDEDOR = 9;
  idx_ReferenciaGenericaNUMTALON = 10;
  idx_ReferenciaGenericaCODIGO_BARRA = 11;
  idx_ReferenciaGenericaCODIGO = 12;
  idx_ReferenciaGenericaPRODUCTO = 13;
  idx_ReferenciaGenericaCOLOR = 14;
  idx_ReferenciaGenericaTALLA = 15;
  idx_ReferenciaGenericaVTAPROCESO = 16;
  idx_ReferenciaGenericaVTAFINAL = 17;
  idx_ReferenciaGenericaVTATERM = 18;
  idx_ReferenciaGenericaVALTOT = 19;
  idx_ReferenciaGenericaESTADO = 20;
  idx_ReferenciaGenericaFECHACAMBIO = 21;

type
  { I_ExisteFilaReferenciaGenerica }
  I_ExisteFilaReferenciaGenerica = interface(IDAStronglyTypedDataTable)
  ['{98972C64-DAD7-4646-90BE-053EFD062BBF}']
    { Property getters and setters }
    function GetNUMINFValue: String;
    procedure SetNUMINFValue(const aValue: String);
    function GetCLAVE1Value: Float;
    procedure SetCLAVE1Value(const aValue: Float);
    function GetCLAVE2Value: Integer;
    procedure SetCLAVE2Value(const aValue: Integer);
    function GetCLAVE3Value: Integer;
    procedure SetCLAVE3Value(const aValue: Integer);
    function GetNUMCONValue: Integer;
    procedure SetNUMCONValue(const aValue: Integer);


    { Properties }
    property NUMINF: String read GetNUMINFValue write SetNUMINFValue;
    property CLAVE1: Float read GetCLAVE1Value write SetCLAVE1Value;
    property CLAVE2: Integer read GetCLAVE2Value write SetCLAVE2Value;
    property CLAVE3: Integer read GetCLAVE3Value write SetCLAVE3Value;
    property NUMCON: Integer read GetNUMCONValue write SetNUMCONValue;
  end;

  { T_ExisteFilaReferenciaGenericaDataTableRules }
  T_ExisteFilaReferenciaGenericaDataTableRules = class(TDADataTableRules, I_ExisteFilaReferenciaGenerica)
  private
  protected
    { Property getters and setters }
    function GetNUMINFValue: String; virtual;
    procedure SetNUMINFValue(const aValue: String); virtual;
    function GetCLAVE1Value: Float; virtual;
    procedure SetCLAVE1Value(const aValue: Float); virtual;
    function GetCLAVE2Value: Integer; virtual;
    procedure SetCLAVE2Value(const aValue: Integer); virtual;
    function GetCLAVE3Value: Integer; virtual;
    procedure SetCLAVE3Value(const aValue: Integer); virtual;
    function GetNUMCONValue: Integer; virtual;
    procedure SetNUMCONValue(const aValue: Integer); virtual;

    { Properties }
    property NUMINF: String read GetNUMINFValue write SetNUMINFValue;
    property CLAVE1: Float read GetCLAVE1Value write SetCLAVE1Value;
    property CLAVE2: Integer read GetCLAVE2Value write SetCLAVE2Value;
    property CLAVE3: Integer read GetCLAVE3Value write SetCLAVE3Value;
    property NUMCON: Integer read GetNUMCONValue write SetNUMCONValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IInformeRefGenerica }
  IInformeRefGenerica = interface(IDAStronglyTypedDataTable)
  ['{6AFE9984-0F66-4AC2-B5E7-87F3C48B81B9}']
    { Property getters and setters }
    function GetCODCENTROValue: String;
    procedure SetCODCENTROValue(const aValue: String);
    function GetCENTROValue: String;
    procedure SetCENTROValue(const aValue: String);
    function GetCODVENDEDORValue: String;
    procedure SetCODVENDEDORValue(const aValue: String);
    function GetVENDEDORValue: String;
    procedure SetVENDEDORValue(const aValue: String);
    function GetFECHAValue: DateTime;
    procedure SetFECHAValue(const aValue: DateTime);
    function GetNUMTALONValue: String;
    procedure SetNUMTALONValue(const aValue: String);
    function GetCANTIDADValue: String;
    procedure SetCANTIDADValue(const aValue: String);
    function GetVALTOTValue: Float;
    procedure SetVALTOTValue(const aValue: Float);


    { Properties }
    property CODCENTRO: String read GetCODCENTROValue write SetCODCENTROValue;
    property CENTRO: String read GetCENTROValue write SetCENTROValue;
    property CODVENDEDOR: String read GetCODVENDEDORValue write SetCODVENDEDORValue;
    property VENDEDOR: String read GetVENDEDORValue write SetVENDEDORValue;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property NUMTALON: String read GetNUMTALONValue write SetNUMTALONValue;
    property CANTIDAD: String read GetCANTIDADValue write SetCANTIDADValue;
    property VALTOT: Float read GetVALTOTValue write SetVALTOTValue;
  end;

  { TInformeRefGenericaDataTableRules }
  TInformeRefGenericaDataTableRules = class(TDADataTableRules, IInformeRefGenerica)
  private
  protected
    { Property getters and setters }
    function GetCODCENTROValue: String; virtual;
    procedure SetCODCENTROValue(const aValue: String); virtual;
    function GetCENTROValue: String; virtual;
    procedure SetCENTROValue(const aValue: String); virtual;
    function GetCODVENDEDORValue: String; virtual;
    procedure SetCODVENDEDORValue(const aValue: String); virtual;
    function GetVENDEDORValue: String; virtual;
    procedure SetVENDEDORValue(const aValue: String); virtual;
    function GetFECHAValue: DateTime; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    function GetNUMTALONValue: String; virtual;
    procedure SetNUMTALONValue(const aValue: String); virtual;
    function GetCANTIDADValue: String; virtual;
    procedure SetCANTIDADValue(const aValue: String); virtual;
    function GetVALTOTValue: Float; virtual;
    procedure SetVALTOTValue(const aValue: Float); virtual;

    { Properties }
    property CODCENTRO: String read GetCODCENTROValue write SetCODCENTROValue;
    property CENTRO: String read GetCENTROValue write SetCENTROValue;
    property CODVENDEDOR: String read GetCODVENDEDORValue write SetCODVENDEDORValue;
    property VENDEDOR: String read GetVENDEDORValue write SetVENDEDORValue;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property NUMTALON: String read GetNUMTALONValue write SetNUMTALONValue;
    property CANTIDAD: String read GetCANTIDADValue write SetCANTIDADValue;
    property VALTOT: Float read GetVALTOTValue write SetVALTOTValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  {
  Datos de una prenda
  }
  { IGetProducto }
  IGetProducto = interface(IDAStronglyTypedDataTable)
  ['{66AEFCA5-9C07-41F0-A81B-9A0965270310}']
    { Property getters and setters }
    function GetCODIGO_BARRAValue: String;
    procedure SetCODIGO_BARRAValue(const aValue: String);
    function GetCOR_PRODUTOValue: String;
    procedure SetCOR_PRODUTOValue(const aValue: String);
    function GetDESC_PRODUTOValue: String;
    procedure SetDESC_PRODUTOValue(const aValue: String);
    function GetPRODUTOValue: String;
    procedure SetPRODUTOValue(const aValue: String);
    function GetGRADEValue: String;
    procedure SetGRADEValue(const aValue: String);


    { Properties }
    property CODIGO_BARRA: String read GetCODIGO_BARRAValue write SetCODIGO_BARRAValue;
    property COR_PRODUTO: String read GetCOR_PRODUTOValue write SetCOR_PRODUTOValue;
    property DESC_PRODUTO: String read GetDESC_PRODUTOValue write SetDESC_PRODUTOValue;
    property PRODUTO: String read GetPRODUTOValue write SetPRODUTOValue;
    property GRADE: String read GetGRADEValue write SetGRADEValue;
  end;

  { TGetProductoDataTableRules }
  TGetProductoDataTableRules = class(TDADataTableRules, IGetProducto)
  private
  protected
    { Property getters and setters }
    function GetCODIGO_BARRAValue: String; virtual;
    procedure SetCODIGO_BARRAValue(const aValue: String); virtual;
    function GetCOR_PRODUTOValue: String; virtual;
    procedure SetCOR_PRODUTOValue(const aValue: String); virtual;
    function GetDESC_PRODUTOValue: String; virtual;
    procedure SetDESC_PRODUTOValue(const aValue: String); virtual;
    function GetPRODUTOValue: String; virtual;
    procedure SetPRODUTOValue(const aValue: String); virtual;
    function GetGRADEValue: String; virtual;
    procedure SetGRADEValue(const aValue: String); virtual;

    { Properties }
    property CODIGO_BARRA: String read GetCODIGO_BARRAValue write SetCODIGO_BARRAValue;
    property COR_PRODUTO: String read GetCOR_PRODUTOValue write SetCOR_PRODUTOValue;
    property DESC_PRODUTO: String read GetDESC_PRODUTOValue write SetDESC_PRODUTOValue;
    property PRODUTO: String read GetPRODUTOValue write SetPRODUTOValue;
    property GRADE: String read GetGRADEValue write SetGRADEValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IReferenciaGenerica }
  IReferenciaGenerica = interface(IDAStronglyTypedDataTable)
  ['{0D8DB24C-6B9C-4DBA-8B26-D007BD14ED85}']
    { Property getters and setters }
    function GetNUMINFValue: String;
    procedure SetNUMINFValue(const aValue: String);
    function GetCLAVE1Value: Float;
    procedure SetCLAVE1Value(const aValue: Float);
    function GetCLAVE2Value: Integer;
    procedure SetCLAVE2Value(const aValue: Integer);
    function GetCLAVE3Value: Integer;
    procedure SetCLAVE3Value(const aValue: Integer);
    function GetNUMCONValue: Integer;
    procedure SetNUMCONValue(const aValue: Integer);
    function GetFECHAValue: DateTime;
    procedure SetFECHAValue(const aValue: DateTime);
    function GetCODCENTROValue: String;
    procedure SetCODCENTROValue(const aValue: String);
    function GetCENTROValue: String;
    procedure SetCENTROValue(const aValue: String);
    function GetCODVENDEDORValue: String;
    procedure SetCODVENDEDORValue(const aValue: String);
    function GetVENDEDORValue: String;
    procedure SetVENDEDORValue(const aValue: String);
    function GetNUMTALONValue: String;
    procedure SetNUMTALONValue(const aValue: String);
    function GetCODIGO_BARRAValue: String;
    procedure SetCODIGO_BARRAValue(const aValue: String);
    function GetCODIGOValue: String;
    procedure SetCODIGOValue(const aValue: String);
    function GetPRODUCTOValue: String;
    procedure SetPRODUCTOValue(const aValue: String);
    function GetCOLORValue: String;
    procedure SetCOLORValue(const aValue: String);
    function GetTALLAValue: String;
    procedure SetTALLAValue(const aValue: String);
    function GetVTAPROCESOValue: Float;
    procedure SetVTAPROCESOValue(const aValue: Float);
    function GetVTAFINALValue: Float;
    procedure SetVTAFINALValue(const aValue: Float);
    function GetVTATERMValue: Float;
    procedure SetVTATERMValue(const aValue: Float);
    function GetVALTOTValue: Float;
    procedure SetVALTOTValue(const aValue: Float);
    function GetESTADOValue: String;
    procedure SetESTADOValue(const aValue: String);
    function GetFECHACAMBIOValue: DateTime;
    procedure SetFECHACAMBIOValue(const aValue: DateTime);


    { Properties }
    property NUMINF: String read GetNUMINFValue write SetNUMINFValue;
    property CLAVE1: Float read GetCLAVE1Value write SetCLAVE1Value;
    property CLAVE2: Integer read GetCLAVE2Value write SetCLAVE2Value;
    property CLAVE3: Integer read GetCLAVE3Value write SetCLAVE3Value;
    property NUMCON: Integer read GetNUMCONValue write SetNUMCONValue;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property CODCENTRO: String read GetCODCENTROValue write SetCODCENTROValue;
    property CENTRO: String read GetCENTROValue write SetCENTROValue;
    property CODVENDEDOR: String read GetCODVENDEDORValue write SetCODVENDEDORValue;
    property VENDEDOR: String read GetVENDEDORValue write SetVENDEDORValue;
    property NUMTALON: String read GetNUMTALONValue write SetNUMTALONValue;
    property CODIGO_BARRA: String read GetCODIGO_BARRAValue write SetCODIGO_BARRAValue;
    property CODIGO: String read GetCODIGOValue write SetCODIGOValue;
    property PRODUCTO: String read GetPRODUCTOValue write SetPRODUCTOValue;
    property COLOR: String read GetCOLORValue write SetCOLORValue;
    property TALLA: String read GetTALLAValue write SetTALLAValue;
    property VTAPROCESO: Float read GetVTAPROCESOValue write SetVTAPROCESOValue;
    property VTAFINAL: Float read GetVTAFINALValue write SetVTAFINALValue;
    property VTATERM: Float read GetVTATERMValue write SetVTATERMValue;
    property VALTOT: Float read GetVALTOTValue write SetVALTOTValue;
    property ESTADO: String read GetESTADOValue write SetESTADOValue;
    property FECHACAMBIO: DateTime read GetFECHACAMBIOValue write SetFECHACAMBIOValue;
  end;

  { TReferenciaGenericaDataTableRules }
  TReferenciaGenericaDataTableRules = class(TDADataTableRules, IReferenciaGenerica)
  private
  protected
    { Property getters and setters }
    function GetNUMINFValue: String; virtual;
    procedure SetNUMINFValue(const aValue: String); virtual;
    function GetCLAVE1Value: Float; virtual;
    procedure SetCLAVE1Value(const aValue: Float); virtual;
    function GetCLAVE2Value: Integer; virtual;
    procedure SetCLAVE2Value(const aValue: Integer); virtual;
    function GetCLAVE3Value: Integer; virtual;
    procedure SetCLAVE3Value(const aValue: Integer); virtual;
    function GetNUMCONValue: Integer; virtual;
    procedure SetNUMCONValue(const aValue: Integer); virtual;
    function GetFECHAValue: DateTime; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    function GetCODCENTROValue: String; virtual;
    procedure SetCODCENTROValue(const aValue: String); virtual;
    function GetCENTROValue: String; virtual;
    procedure SetCENTROValue(const aValue: String); virtual;
    function GetCODVENDEDORValue: String; virtual;
    procedure SetCODVENDEDORValue(const aValue: String); virtual;
    function GetVENDEDORValue: String; virtual;
    procedure SetVENDEDORValue(const aValue: String); virtual;
    function GetNUMTALONValue: String; virtual;
    procedure SetNUMTALONValue(const aValue: String); virtual;
    function GetCODIGO_BARRAValue: String; virtual;
    procedure SetCODIGO_BARRAValue(const aValue: String); virtual;
    function GetCODIGOValue: String; virtual;
    procedure SetCODIGOValue(const aValue: String); virtual;
    function GetPRODUCTOValue: String; virtual;
    procedure SetPRODUCTOValue(const aValue: String); virtual;
    function GetCOLORValue: String; virtual;
    procedure SetCOLORValue(const aValue: String); virtual;
    function GetTALLAValue: String; virtual;
    procedure SetTALLAValue(const aValue: String); virtual;
    function GetVTAPROCESOValue: Float; virtual;
    procedure SetVTAPROCESOValue(const aValue: Float); virtual;
    function GetVTAFINALValue: Float; virtual;
    procedure SetVTAFINALValue(const aValue: Float); virtual;
    function GetVTATERMValue: Float; virtual;
    procedure SetVTATERMValue(const aValue: Float); virtual;
    function GetVALTOTValue: Float; virtual;
    procedure SetVALTOTValue(const aValue: Float); virtual;
    function GetESTADOValue: String; virtual;
    procedure SetESTADOValue(const aValue: String); virtual;
    function GetFECHACAMBIOValue: DateTime; virtual;
    procedure SetFECHACAMBIOValue(const aValue: DateTime); virtual;

    { Properties }
    property NUMINF: String read GetNUMINFValue write SetNUMINFValue;
    property CLAVE1: Float read GetCLAVE1Value write SetCLAVE1Value;
    property CLAVE2: Integer read GetCLAVE2Value write SetCLAVE2Value;
    property CLAVE3: Integer read GetCLAVE3Value write SetCLAVE3Value;
    property NUMCON: Integer read GetNUMCONValue write SetNUMCONValue;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property CODCENTRO: String read GetCODCENTROValue write SetCODCENTROValue;
    property CENTRO: String read GetCENTROValue write SetCENTROValue;
    property CODVENDEDOR: String read GetCODVENDEDORValue write SetCODVENDEDORValue;
    property VENDEDOR: String read GetVENDEDORValue write SetVENDEDORValue;
    property NUMTALON: String read GetNUMTALONValue write SetNUMTALONValue;
    property CODIGO_BARRA: String read GetCODIGO_BARRAValue write SetCODIGO_BARRAValue;
    property CODIGO: String read GetCODIGOValue write SetCODIGOValue;
    property PRODUCTO: String read GetPRODUCTOValue write SetPRODUCTOValue;
    property COLOR: String read GetCOLORValue write SetCOLORValue;
    property TALLA: String read GetTALLAValue write SetTALLAValue;
    property VTAPROCESO: Float read GetVTAPROCESOValue write SetVTAPROCESOValue;
    property VTAFINAL: Float read GetVTAFINALValue write SetVTAFINALValue;
    property VTATERM: Float read GetVTATERMValue write SetVTATERMValue;
    property VALTOT: Float read GetVALTOTValue write SetVALTOTValue;
    property ESTADO: String read GetESTADOValue write SetESTADOValue;
    property FECHACAMBIO: DateTime read GetFECHACAMBIOValue write SetFECHACAMBIOValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants;

{ T_ExisteFilaReferenciaGenericaDataTableRules }
constructor T_ExisteFilaReferenciaGenericaDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor T_ExisteFilaReferenciaGenericaDataTableRules.Destroy;
begin
  inherited;
end;

function T_ExisteFilaReferenciaGenericaDataTableRules.GetNUMINFValue: String;
begin
  result := DataTable.Fields[idx__ExisteFilaReferenciaGenericaNUMINF].AsString;
end;

procedure T_ExisteFilaReferenciaGenericaDataTableRules.SetNUMINFValue(const aValue: String);
begin
  DataTable.Fields[idx__ExisteFilaReferenciaGenericaNUMINF].AsString := aValue;
end;

function T_ExisteFilaReferenciaGenericaDataTableRules.GetCLAVE1Value: Float;
begin
  result := DataTable.Fields[idx__ExisteFilaReferenciaGenericaCLAVE1].AsFloat;
end;

procedure T_ExisteFilaReferenciaGenericaDataTableRules.SetCLAVE1Value(const aValue: Float);
begin
  DataTable.Fields[idx__ExisteFilaReferenciaGenericaCLAVE1].AsFloat := aValue;
end;

function T_ExisteFilaReferenciaGenericaDataTableRules.GetCLAVE2Value: Integer;
begin
  result := DataTable.Fields[idx__ExisteFilaReferenciaGenericaCLAVE2].AsInteger;
end;

procedure T_ExisteFilaReferenciaGenericaDataTableRules.SetCLAVE2Value(const aValue: Integer);
begin
  DataTable.Fields[idx__ExisteFilaReferenciaGenericaCLAVE2].AsInteger := aValue;
end;

function T_ExisteFilaReferenciaGenericaDataTableRules.GetCLAVE3Value: Integer;
begin
  result := DataTable.Fields[idx__ExisteFilaReferenciaGenericaCLAVE3].AsInteger;
end;

procedure T_ExisteFilaReferenciaGenericaDataTableRules.SetCLAVE3Value(const aValue: Integer);
begin
  DataTable.Fields[idx__ExisteFilaReferenciaGenericaCLAVE3].AsInteger := aValue;
end;

function T_ExisteFilaReferenciaGenericaDataTableRules.GetNUMCONValue: Integer;
begin
  result := DataTable.Fields[idx__ExisteFilaReferenciaGenericaNUMCON].AsInteger;
end;

procedure T_ExisteFilaReferenciaGenericaDataTableRules.SetNUMCONValue(const aValue: Integer);
begin
  DataTable.Fields[idx__ExisteFilaReferenciaGenericaNUMCON].AsInteger := aValue;
end;


{ TInformeRefGenericaDataTableRules }
constructor TInformeRefGenericaDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TInformeRefGenericaDataTableRules.Destroy;
begin
  inherited;
end;

function TInformeRefGenericaDataTableRules.GetCODCENTROValue: String;
begin
  result := DataTable.Fields[idx_InformeRefGenericaCODCENTRO].AsString;
end;

procedure TInformeRefGenericaDataTableRules.SetCODCENTROValue(const aValue: String);
begin
  DataTable.Fields[idx_InformeRefGenericaCODCENTRO].AsString := aValue;
end;

function TInformeRefGenericaDataTableRules.GetCENTROValue: String;
begin
  result := DataTable.Fields[idx_InformeRefGenericaCENTRO].AsString;
end;

procedure TInformeRefGenericaDataTableRules.SetCENTROValue(const aValue: String);
begin
  DataTable.Fields[idx_InformeRefGenericaCENTRO].AsString := aValue;
end;

function TInformeRefGenericaDataTableRules.GetCODVENDEDORValue: String;
begin
  result := DataTable.Fields[idx_InformeRefGenericaCODVENDEDOR].AsString;
end;

procedure TInformeRefGenericaDataTableRules.SetCODVENDEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_InformeRefGenericaCODVENDEDOR].AsString := aValue;
end;

function TInformeRefGenericaDataTableRules.GetVENDEDORValue: String;
begin
  result := DataTable.Fields[idx_InformeRefGenericaVENDEDOR].AsString;
end;

procedure TInformeRefGenericaDataTableRules.SetVENDEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_InformeRefGenericaVENDEDOR].AsString := aValue;
end;

function TInformeRefGenericaDataTableRules.GetFECHAValue: DateTime;
begin
  result := DataTable.Fields[idx_InformeRefGenericaFECHA].AsDateTime;
end;

procedure TInformeRefGenericaDataTableRules.SetFECHAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_InformeRefGenericaFECHA].AsDateTime := aValue;
end;

function TInformeRefGenericaDataTableRules.GetNUMTALONValue: String;
begin
  result := DataTable.Fields[idx_InformeRefGenericaNUMTALON].AsString;
end;

procedure TInformeRefGenericaDataTableRules.SetNUMTALONValue(const aValue: String);
begin
  DataTable.Fields[idx_InformeRefGenericaNUMTALON].AsString := aValue;
end;

function TInformeRefGenericaDataTableRules.GetCANTIDADValue: String;
begin
  result := DataTable.Fields[idx_InformeRefGenericaCANTIDAD].AsString;
end;

procedure TInformeRefGenericaDataTableRules.SetCANTIDADValue(const aValue: String);
begin
  DataTable.Fields[idx_InformeRefGenericaCANTIDAD].AsString := aValue;
end;

function TInformeRefGenericaDataTableRules.GetVALTOTValue: Float;
begin
  result := DataTable.Fields[idx_InformeRefGenericaVALTOT].AsFloat;
end;

procedure TInformeRefGenericaDataTableRules.SetVALTOTValue(const aValue: Float);
begin
  DataTable.Fields[idx_InformeRefGenericaVALTOT].AsFloat := aValue;
end;


{ TGetProductoDataTableRules }
constructor TGetProductoDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TGetProductoDataTableRules.Destroy;
begin
  inherited;
end;

function TGetProductoDataTableRules.GetCODIGO_BARRAValue: String;
begin
  result := DataTable.Fields[idx_GetProductoCODIGO_BARRA].AsString;
end;

procedure TGetProductoDataTableRules.SetCODIGO_BARRAValue(const aValue: String);
begin
  DataTable.Fields[idx_GetProductoCODIGO_BARRA].AsString := aValue;
end;

function TGetProductoDataTableRules.GetCOR_PRODUTOValue: String;
begin
  result := DataTable.Fields[idx_GetProductoCOR_PRODUTO].AsString;
end;

procedure TGetProductoDataTableRules.SetCOR_PRODUTOValue(const aValue: String);
begin
  DataTable.Fields[idx_GetProductoCOR_PRODUTO].AsString := aValue;
end;

function TGetProductoDataTableRules.GetDESC_PRODUTOValue: String;
begin
  result := DataTable.Fields[idx_GetProductoDESC_PRODUTO].AsString;
end;

procedure TGetProductoDataTableRules.SetDESC_PRODUTOValue(const aValue: String);
begin
  DataTable.Fields[idx_GetProductoDESC_PRODUTO].AsString := aValue;
end;

function TGetProductoDataTableRules.GetPRODUTOValue: String;
begin
  result := DataTable.Fields[idx_GetProductoPRODUTO].AsString;
end;

procedure TGetProductoDataTableRules.SetPRODUTOValue(const aValue: String);
begin
  DataTable.Fields[idx_GetProductoPRODUTO].AsString := aValue;
end;

function TGetProductoDataTableRules.GetGRADEValue: String;
begin
  result := DataTable.Fields[idx_GetProductoGRADE].AsString;
end;

procedure TGetProductoDataTableRules.SetGRADEValue(const aValue: String);
begin
  DataTable.Fields[idx_GetProductoGRADE].AsString := aValue;
end;


{ TReferenciaGenericaDataTableRules }
constructor TReferenciaGenericaDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TReferenciaGenericaDataTableRules.Destroy;
begin
  inherited;
end;

function TReferenciaGenericaDataTableRules.GetNUMINFValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaNUMINF].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetNUMINFValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaNUMINF].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetCLAVE1Value: Float;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCLAVE1].AsFloat;
end;

procedure TReferenciaGenericaDataTableRules.SetCLAVE1Value(const aValue: Float);
begin
  DataTable.Fields[idx_ReferenciaGenericaCLAVE1].AsFloat := aValue;
end;

function TReferenciaGenericaDataTableRules.GetCLAVE2Value: Integer;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCLAVE2].AsInteger;
end;

procedure TReferenciaGenericaDataTableRules.SetCLAVE2Value(const aValue: Integer);
begin
  DataTable.Fields[idx_ReferenciaGenericaCLAVE2].AsInteger := aValue;
end;

function TReferenciaGenericaDataTableRules.GetCLAVE3Value: Integer;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCLAVE3].AsInteger;
end;

procedure TReferenciaGenericaDataTableRules.SetCLAVE3Value(const aValue: Integer);
begin
  DataTable.Fields[idx_ReferenciaGenericaCLAVE3].AsInteger := aValue;
end;

function TReferenciaGenericaDataTableRules.GetNUMCONValue: Integer;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaNUMCON].AsInteger;
end;

procedure TReferenciaGenericaDataTableRules.SetNUMCONValue(const aValue: Integer);
begin
  DataTable.Fields[idx_ReferenciaGenericaNUMCON].AsInteger := aValue;
end;

function TReferenciaGenericaDataTableRules.GetFECHAValue: DateTime;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaFECHA].AsDateTime;
end;

procedure TReferenciaGenericaDataTableRules.SetFECHAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_ReferenciaGenericaFECHA].AsDateTime := aValue;
end;

function TReferenciaGenericaDataTableRules.GetCODCENTROValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCODCENTRO].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetCODCENTROValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaCODCENTRO].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetCENTROValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCENTRO].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetCENTROValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaCENTRO].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetCODVENDEDORValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCODVENDEDOR].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetCODVENDEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaCODVENDEDOR].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetVENDEDORValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaVENDEDOR].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetVENDEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaVENDEDOR].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetNUMTALONValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaNUMTALON].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetNUMTALONValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaNUMTALON].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetCODIGO_BARRAValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCODIGO_BARRA].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetCODIGO_BARRAValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaCODIGO_BARRA].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetCODIGOValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCODIGO].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetCODIGOValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaCODIGO].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetPRODUCTOValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaPRODUCTO].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetPRODUCTOValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaPRODUCTO].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetCOLORValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaCOLOR].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetCOLORValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaCOLOR].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetTALLAValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaTALLA].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetTALLAValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaTALLA].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetVTAPROCESOValue: Float;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaVTAPROCESO].AsFloat;
end;

procedure TReferenciaGenericaDataTableRules.SetVTAPROCESOValue(const aValue: Float);
begin
  DataTable.Fields[idx_ReferenciaGenericaVTAPROCESO].AsFloat := aValue;
end;

function TReferenciaGenericaDataTableRules.GetVTAFINALValue: Float;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaVTAFINAL].AsFloat;
end;

procedure TReferenciaGenericaDataTableRules.SetVTAFINALValue(const aValue: Float);
begin
  DataTable.Fields[idx_ReferenciaGenericaVTAFINAL].AsFloat := aValue;
end;

function TReferenciaGenericaDataTableRules.GetVTATERMValue: Float;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaVTATERM].AsFloat;
end;

procedure TReferenciaGenericaDataTableRules.SetVTATERMValue(const aValue: Float);
begin
  DataTable.Fields[idx_ReferenciaGenericaVTATERM].AsFloat := aValue;
end;

function TReferenciaGenericaDataTableRules.GetVALTOTValue: Float;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaVALTOT].AsFloat;
end;

procedure TReferenciaGenericaDataTableRules.SetVALTOTValue(const aValue: Float);
begin
  DataTable.Fields[idx_ReferenciaGenericaVALTOT].AsFloat := aValue;
end;

function TReferenciaGenericaDataTableRules.GetESTADOValue: String;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaESTADO].AsString;
end;

procedure TReferenciaGenericaDataTableRules.SetESTADOValue(const aValue: String);
begin
  DataTable.Fields[idx_ReferenciaGenericaESTADO].AsString := aValue;
end;

function TReferenciaGenericaDataTableRules.GetFECHACAMBIOValue: DateTime;
begin
  result := DataTable.Fields[idx_ReferenciaGenericaFECHACAMBIO].AsDateTime;
end;

procedure TReferenciaGenericaDataTableRules.SetFECHACAMBIOValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_ReferenciaGenericaFECHACAMBIO].AsDateTime := aValue;
end;


initialization
  RegisterDataTableRules(RID__ExisteFilaReferenciaGenerica, T_ExisteFilaReferenciaGenericaDataTableRules);
  RegisterDataTableRules(RID_InformeRefGenerica, TInformeRefGenericaDataTableRules);
  RegisterDataTableRules(RID_GetProducto, TGetProductoDataTableRules);
  RegisterDataTableRules(RID_ReferenciaGenerica, TReferenciaGenericaDataTableRules);

end.
